/**
 * NOTE: This class is auto generated by the swagger code generator program (2.4.21).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package mx.sidlors.dvd.rental.api;

import  mx.sidlors.dvd.rental.model.Customer;
import org.threeten.bp.LocalDate;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2021-07-21T02:33:33.560Z")

@Validated
@Api(value = "customer", description = "the customer API")
@RequestMapping(value = "")
public interface CustomerApi {

    @ApiOperation(value = "", nickname = "customerDelete", notes = "", tags={ "customer", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/customer",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.DELETE)
    ResponseEntity<Void> customerDelete(@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "store_id", required = false) String storeId,@ApiParam(value = "") @Valid @RequestParam(value = "first_name", required = false) String firstName,@ApiParam(value = "") @Valid @RequestParam(value = "last_name", required = false) String lastName,@ApiParam(value = "") @Valid @RequestParam(value = "email", required = false) String email,@ApiParam(value = "") @Valid @RequestParam(value = "address_id", required = false) String addressId,@ApiParam(value = "") @Valid @RequestParam(value = "activebool", required = false) String activebool,@ApiParam(value = "") @Valid @RequestParam(value = "create_date", required = false) LocalDate createDate,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "") @Valid @RequestParam(value = "active", required = false) String active,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "customerGet", notes = "", response = Customer.class, responseContainer = "List", tags={ "customer", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Customer.class, responseContainer = "List"),
        @ApiResponse(code = 206, message = "Partial Content") })
    @RequestMapping(value = "/customer",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.GET)
    ResponseEntity<List<Customer>> customerGet(@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "store_id", required = false) String storeId,@ApiParam(value = "") @Valid @RequestParam(value = "first_name", required = false) String firstName,@ApiParam(value = "") @Valid @RequestParam(value = "last_name", required = false) String lastName,@ApiParam(value = "") @Valid @RequestParam(value = "email", required = false) String email,@ApiParam(value = "") @Valid @RequestParam(value = "address_id", required = false) String addressId,@ApiParam(value = "") @Valid @RequestParam(value = "activebool", required = false) String activebool,@ApiParam(value = "") @Valid @RequestParam(value = "create_date", required = false) LocalDate createDate,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "") @Valid @RequestParam(value = "active", required = false) String active,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Ordering") @Valid @RequestParam(value = "order", required = false) String order,@ApiParam(value = "Limiting and Pagination" ) @RequestHeader(value="Range", required=false) String range,@ApiParam(value = "Limiting and Pagination" , defaultValue="items") @RequestHeader(value="Range-Unit", required=false) String rangeUnit,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "offset", required = false) String offset,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "limit", required = false) String limit,@ApiParam(value = "Preference" , allowableValues="count=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "customerPatch", notes = "", tags={ "customer", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/customer",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.PATCH)
    ResponseEntity<Void> customerPatch(@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "store_id", required = false) String storeId,@ApiParam(value = "") @Valid @RequestParam(value = "first_name", required = false) String firstName,@ApiParam(value = "") @Valid @RequestParam(value = "last_name", required = false) String lastName,@ApiParam(value = "") @Valid @RequestParam(value = "email", required = false) String email,@ApiParam(value = "") @Valid @RequestParam(value = "address_id", required = false) String addressId,@ApiParam(value = "") @Valid @RequestParam(value = "activebool", required = false) String activebool,@ApiParam(value = "") @Valid @RequestParam(value = "create_date", required = false) LocalDate createDate,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "") @Valid @RequestParam(value = "active", required = false) String active,@ApiParam(value = "customer"  )  @Valid @RequestBody Customer customer,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "customerPost", notes = "", tags={ "customer", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "Created") })
    @RequestMapping(value = "/customer",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.POST)
    ResponseEntity<Void> customerPost(@ApiParam(value = "customer"  )  @Valid @RequestBody Customer customer,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);

}
